$! Xerces 1.3.0, Samples
$! xer_sample.com
$!
$! P1 - Appended to the ".EXE" of the resultant linked image.
$!	If it contains "DEBUG" then compile and link will be /debug/nooptim.
$!
$! ---------------------------------------------------------------------------
$! Modification History
$!
$! 22-Jan-2001	Karl Puder
$!	Made logicals relative rather than absolute, for portability.
$!
$! 20-Jan-2001  Shafiq Ahmed
$!      Fixed a bug in do_link to create correct cxx_repository locale.
$!
$! 19-Jan-2001  Shafiq Ahmed
$!      Made more succinct
$!
$! 17-Jan-2001	Karl Puder
$!	Added /NoOptimiz to /Debug.
$!
$! 12-Jan-2001	Karl Puder
$!	Restructured subroutines.
$!	Put test files (.OBJ, .EXE, [.cxx_repository]) in the test directory.
$!	Run the test in its own directory.
$!
$! 12-Jan-2001	Shafiq Ahmed
$!	Added the other tests.
$!
$! 9-Jan-2001	Karl Puder
$!	Included compile and link commands directly in this file.
$!	Added P1 as name extension and debug flag.
$!
$! 6-Jan-2001   Shafiq Ahmed
$!      First draft.
$!
$! ---------------------------------------------------------------------------
$do_cpp: SUBROUTINE
$ write sys$output "C++: Compiling Sample program ''p1'"
$ src_file = f$parse(p1,".cpp")
$ obj_file = f$parse(".obj;",p1)
$ list_file = f$parse(".lis;",p1)
$ repos = f$parse("A.B",p1,"[];") - "]A.B;" + ".CXX_REPOSITORY]"
$ cxx 'src_file' 'p2' -
	/listing='list_file' -
	/OBJECT='obj_file' -
	/INCLUDE=(CXX$USER_INCLUDE) -
	/repository=('repos',CXX_REPOSITORY:)
$ exit
$ ENDSUBROUTINE
$! ---------------------------------------------------------------------------
$do_link: SUBROUTINE
$ write sys$output "C++: Linking Object Module ''p1'"
$ first_name = f$element(0,",",f$element(0,"+",p1))
$ exec_file = f$parse(".exe''p3'",first_name)
$ map_file = f$parse(".map''p3'",first_name)
$! Since we put the .obj file in the source directory, this finds
$! the same directory as the line like it in do_cpp.
$ repos = f$parse("A.B",first_name,"[];") - "]A.B;" + ".CXX_REPOSITORY]"
$ cxxlink 'p1', -
        [-.lib]Xerces'p3'.olb/library -
	'p2' -
	/EXECUTABLE= 'exec_file' -
	/map='map_file' -
	/repository=('repos',CXX_REPOSITORY:)
$ exit
$ ENDSUBROUTINE
$! ---------------------------------------------------------------------------
$do_run: SUBROUTINE
$ write sys$output "VMS: Running ''p1'"
$ write sys$output ""
$ exename = "$"+f$parse("sys$disk:.exe''p3'",p1)
$
$ if p2 .nes. ""
$ then
$    exename "''p2'"
$ else
$    exename
$ endif
$
$ write sys$output ""
$ write sys$output ""
$ exit
$ ENDSUBROUTINE
$! ---------------------------------------------------------------------------
$do_build_link_run: SUBROUTINE
$ call do_cpp "''p1'" "''p3'"
$
$ if p2 .nes. ""
$ then
$   call do_cpp "''p2'" "''p3'"
$   call do_link "''p1'+''p2'" "''p4'" "''p6'"
$ else
$   call do_link "''p1'" "''p4'" "''p6'"
$ endif
$
$ call do_run  "''p1'" "''p5'" "''p6'"
$ exit
$ ENDSUBROUTINE
$! ------------------------------------------------------------------------------------------
$ if p1 - "DEBUG" .nes. p1
$ then
$  debug_qual = "/debug/nooptimiz"
$  link_debug_qual = "/debug"
$ else
$  debug_qual = ""
$  link_debug_qual = ""
$ endif
$ prm = "../samples/data/personal.xml"
$ define CXX$USER_INCLUDE [-]	! DISK$USERSPACE:[xml.xerces-c-src1_3_0]
$ define CXX_REPOSITORY [.cxx_repository]	! DISK$USERSPACE:[XML.XERCES-C-SRC1_3_0.SRC.CXX_REPOSITORY]
$ write sys$output "++++++++++++++++++++++++++ Cleaning Sample Area ++++++++++++++++++++++++++++++++"
$ purge [-.samples...]
$ write sys$output "+++++++++++++++++++++++++++ Cleaning complete ++++++++++++++++++++++++++++++++++"
$ write sys$output ""
$ write sys$output "++++++++++++++++++++++++++++++++ (1) SAXCount ++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.SAXCount]SAXCount"
$ optmod = "[-.samples.SAXCount]SAXCountHandlers"
$ call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (2) SAXPrint ++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.SAXPrint]SAXPrint"
$ optmod = "[-.samples.SAXPrint]SAXPrintHandlers"
$ call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (3) DOMCount ++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.DOMCount]DOMCount"
$ call do_build_link_run "''module'" "" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (4) DOMPrint ++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.DOMPrint]DOMPrint"
$ optmod = "[-.samples.DOMPrint]DOMTreeErrorReporter"
$ call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (5) MemParse ++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.MemParse]MemParse"
$ optmod = "[-.samples.MemParse]MemParseHandlers"
$ call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (6) Redirect ++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.Redirect]Redirect"
$ optmod = "[-.samples.Redirect]RedirectHandlers"
$ call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (7) PParse ++++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.PParse]PParse"
$ optmod = "[-.samples.PParse]PParseHandlers"
$ call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (8) StdInParse  +++++++++++++++++++++++++++++++"
$ module = "[-.samples.StdInParse]StdInParse"
$ optmod = "[-.samples.StdInParse]StdInParseHandlers"
$! call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$! Must customize this test to use statndard input.
$ call do_cpp "''module'" "''debug_qual'"
$ call do_cpp "''optmod'" "''debug_qual'"
$ call do_link "''module'+''optmod'" "''link_debug_qual'" "''p1'"
$
$! define/user sys$input "''prm'"
$ define/user dbg$input sys$command:
$ write sys$output "VMS: Running ''p1'"
$ write sys$output ""
$ exename = "$"+f$parse("sys$disk:.exe''p3'",module)
$ exename
<?xml version="1.0" encoding="iso-8859-1"?>
<item>
 <part label="innards">
  <piece label="screw">
   3/8 inch
  </piece>
  <piece label="plate">
   3x5
  </piece>
 </part>
 <part label="shell">
  <piece label="case">
   Consumer version
  </piece>
 </part>
</item>
$
$ write sys$output ""
$ write sys$output ""
$ write sys$output "++++++++++++++++++++++++++++++++ (9) EnumVal +++++++++++++++++++++++++++++++++++"
$ module = "[-.samples.EnumVal]EnumVal"
$ call do_build_link_run "''module'" "" "''debug_qual'" "''link_debug_qual'" "''prm'" "''p1'"
$ write sys$output "++++++++++++++++++++++++++++++++ (10) CreateDomDocument ++++++++++++++++++++++++"
$ module = "[-.samples.CreateDomDocument]CreateDomDocument"
$ call do_build_link_run "''module'" "''optmod'" "''debug_qual'" "''link_debug_qual'" "" "''p1'"
$ write sys$output "+++++++++++++++++++++++++++ End of All Apache Tests ++++++++++++++++++++++++++++"
